#include "TestFixture.h"

class PaneOptions : public Gtk_Frame
{
public:
  PaneOptions(Gtk_Paned &paned,
	      const string &frame_label,
	      const string &label1,
	      const string &label2);

  void toggleResize(bool isChild1);
  void toggleShrink(bool isChild1);

private:
  Gtk_Table table;
  Gtk_Label label1, label2;
  Gtk_CheckButton resize1, shrink1,
    resize2, shrink2;

  Gtk_Paned &refPaned;
  
};

class PaneTest : public TestFixture
{
  public:
  static TestFixture *  create ();
  virtual              ~PaneTest ();
  virtual void          destroyTest () { delete theTest; theTest = 0; }
                        PaneTest ();
private:
  // data
  static PaneTest * theTest;
  Gtk_Frame           frame1, frame2, frame3;
  Gtk_HPaned          hpaned;
  Gtk_VPaned          vpaned;
  Gtk_Button          button;
  Gtk_VBox            vbox;

  PaneOptions         *hpaneOptions, *vpaneOptions;
  
};

